Scriptname TC_MCMQuest_Script extends SKI_ConfigBase 
{renn's Tweak 405}
; -----

GlobalVariable Property TC_ExpMultiplier_Global Auto
GlobalVariable Property TC_HealStrengthPct_Global Auto
GlobalVariable Property TC_NoDragonSouls Auto
GlobalVariable Property TC_DisableMeditationEffects_Global Auto

String Property TC_HeaderCompatibility Auto Hidden
String Property TC_HeaderBalance Auto Hidden
String Property TC_HeaderGraphics Auto Hidden
String Property TC_HeaderTroubleshooting Auto Hidden

String Property TC_NameExpMultiplier Auto Hidden
String Property TC_NameHealStrengthPct Auto Hidden
String Property TC_NameStatueToggle Auto Hidden
String Property TC_NameNoDragonSouls Auto Hidden
String Property TC_NameDisableMeditationEffects Auto Hidden

String Property TC_DialogExpMultiplier Auto Hidden
String Property TC_DialogHealStrengthPct Auto Hidden

String Property TC_InfoExpMultiplier Auto Hidden
String Property TC_InfoScriptedDamage Auto Hidden
String Property TC_InfoHealStrengthPct Auto Hidden
String Property TC_InfoStatueToggle Auto Hidden
String Property TC_InfoNoDragonSouls Auto Hidden
String Property TC_InfoDisableMeditationEffects Auto Hidden
;Effect/HUD 0=Show/Hide 1=Hide/Hide 2=Show/Show 3=Hide/Show

ObjectReference Property TC_StatueToggle Auto

; -----

Int OIDExpMultiplier
Int OIDScriptedDamage
Int OIDHealStrengthPct
Int OIDStatueToggle
Int OIDNoDragonSouls
Int OIDDisableMeditationEffects

; -----

Event OnPageReset(string page)

	SetCursorPosition(0)
	SetCursorFillMode(TOP_TO_BOTTOM)
	
	AddHeaderOption("Compatibility")

	OIDExpMultiplier = AddSliderOption("Shouting Gives Speech Exp", TC_ExpMultiplier_Global.GetValueInt(), "x{2}")

	SetCursorPosition(1)
	SetCursorFillMode(TOP_TO_BOTTOM)

	AddHeaderOption("Balance")

;	OIDHealStrengthPct = AddSliderOption("Scripted Healing", TC_HealStrengthPct_Global.GetValue(), "x{2} Effectiveness")
	OIDNoDragonSouls = AddToggleOption("No Dragon Souls from Kyne", TC_NoDragonSouls.GetValue() as Bool)

	AddEmptyOption()
	AddHeaderOption("Graphics")

	OIDStatueToggle = AddToggleOption("Classic Shrine to Kyne", TC_StatueToggle.IsDisabled())

	AddEmptyOption()
	AddHeaderOption("Troubleshooting")
	
	if TC_DisableMeditationEffects_Global.GetValue() >= 1	;renn
		TC_DisableMeditationEffects_Global.SetValue(1)
	endif
	OIDDisableMeditationEffects = AddToggleOption("Show Tip", TC_DisableMeditationEffects_Global.GetValue() as Bool)
	
	AddEmptyOption()
	AddTextOptionST("rennState", "Remove Meditation Effects", "GO!")
	
EndEvent

; -----

Event OnOptionSelect(int option)

	If (option == OIDStatueToggle)
		If TC_StatueToggle.IsDisabled()
			TC_StatueToggle.Enable()
		Else
			TC_StatueToggle.Disable()
		EndIf
		SetToggleOptionValue(OIDStatueToggle, TC_StatueToggle.IsDisabled())
	ElseIf (option == OIDNoDragonSouls)
		If TC_NoDragonSouls.GetValue() == 0.0
			TC_NoDragonSouls.SetValue(1.0)
		Else
			TC_NoDragonSouls.SetValue(0.0)
		EndIf
		SetToggleOptionValue(OIDNoDragonSouls, TC_NoDragonSouls.GetValue() as Bool)
	ElseIf (option == OIDDisableMeditationEffects)
		If TC_DisableMeditationEffects_Global.GetValue() == 0.0
			TC_DisableMeditationEffects_Global.SetValue(1.0)
		Else
			TC_DisableMeditationEffects_Global.SetValue(0.0)
		EndIf
		SetToggleOptionValue(OIDDisableMeditationEffects, TC_DisableMeditationEffects_Global.GetValue() as Bool)
	EndIf

EndEvent

; -----

Event OnOptionHighlight(int option)

	If (option == OIDExpMultiplier)
		SetInfoText("Enables gaining Speechcraft experience for shouting. The amount of experience gained depends on the actual cooldown of the shout multiplied by this value.")
	ElseIf (option == OIDScriptedDamage)
		SetInfoText("Multiplies the damage of scripted shouts, which are not affected by difficulty level: Annihilate 1 and 2, Oblivion 2 and Speak Unto The Stars 1.")
	ElseIf (option == OIDHealStrengthPct)
		SetInfoText("Multiplies the damage of scripted healing. Change this for balance in a high lethality or high attrition environment.")
	ElseIf (option == OIDStatueToggle)
		SetInfoText("Reverts the shrine to Kyne in the High Hrothgar Library to an improved version of the model found in previous versions of Thunderchild. This is a cosmetic change and has no effect on gameplay.")
	ElseIf (option == OIDNoDragonSouls)
		SetInfoText("Disables gaining Dragon Souls as random rewards for pleasing Kyne. By default, you may gain Dragon Souls whenever you perform an act that grants favor. The chance to gain a Dragon Soul decreases each time you gain one this way.")
	ElseIf (option == OIDDisableMeditationEffects)
		SetInfoText("Disables the screen filter Imod and music while meditation.")
	EndIf

EndEvent

; -----

Event OnOptionSliderOpen(int option)

	If (option == OIDExpMultiplier)
		SetSliderDialogStartValue(TC_ExpMultiplier_Global.GetValueInt())
		SetSliderDialogDefaultValue(0)
		SetSliderDialogRange(0, 10)
		SetSliderDialogInterval(1)
	ElseIf (option == OIDHealStrengthPct)
		SetSliderDialogStartValue(TC_HealStrengthPct_Global.GetValue())
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 4.0)
		SetSliderDialogInterval(0.5)
	EndIf

EndEvent

; -----

Event OnOptionSliderAccept(int option, float value)

	If (option == OIDExpMultiplier)
		TC_ExpMultiplier_Global.SetValueInt(value as Int)
		SetSliderOptionValue(OIDExpMultiplier, TC_ExpMultiplier_Global.GetValueInt(), "x{2}")
	ElseIf (option == OIDHealStrengthPct)
		TC_HealStrengthPct_Global.SetValue(value)
		SetSliderOptionValue(OIDHealStrengthPct, TC_HealStrengthPct_Global.GetValue(), "x{2} Effectiveness")
	EndIf

EndEvent

; -----

Event OnOptionDefault(int option)

	If (option == OIDStatueToggle)
		SetToggleOptionValue(OIDStatueToggle, false)
		TC_StatueToggle.Disable()
	ElseIf (option == OIDNoDragonSouls)
		SetToggleOptionValue(OIDNoDragonSouls, false)
		TC_NoDragonSouls.SetValue(0.0)
	ElseIf (option == OIDDisableMeditationEffects)
		SetToggleOptionValue(OIDDisableMeditationEffects, false)
		TC_DisableMeditationEffects_Global.SetValue(0.0)
	EndIf

EndEvent

; -----

state rennState
	event OnSelectST()
		if ShowMessage("Do you want to remove the meditation effects? Only works while you are not sitting.", true)
			if !Game.GetPlayer().GetSitState() != 0
				RemoveMeditationEffects()
				ShowMessage("Removed all the effects.", false)
			else
				if ShowMessage("Are you still in meditation? If not, click yes to continue.", true)
					RemoveMeditationEffects()
					ShowMessage("Removed all the effects.", false)
				else
					ShowMessage("Cannot do this while you are sitting and meditating.", false)
				endif
			endif
		endif
	endEvent
	event OnHighlightST()
		SetInfoText("Remove the meditation effects.")
	endEvent
endState

function RemoveMeditationEffects()
;	Location HighHrothgarLocation = Game.GetFormFromFile(0x00018E34, "Skyrim.esm") as Location
	ImagespaceModifier TC_MeditationISMD = Game.GetFormFromFile(0x0006D05E, "Thunderchild - Epic Shout Package.esp") as ImagespaceModifier
	ImagespaceModifier TC_MeditationISMDIn = Game.GetFormFromFile(0x0006DB4B, "Thunderchild - Epic Shout Package.esp") as ImagespaceModifier
	ImagespaceModifier TC_MeditationISMDOvertime = Game.GetFormFromFile(0x0006DB4E, "Thunderchild - Epic Shout Package.esp") as ImagespaceModifier
	MusicType TC_MeditateMusicType = Game.GetFormFromFile(0x0006D5C2, "Thunderchild - Epic Shout Package.esp") as MusicType
	TC_MeditationISMD.Remove()				
	TC_MeditationISMDIn.Remove()
	TC_MeditationISMDOvertime.Remove()
	TC_MeditateMusicType.Remove()
	Game.EnablePlayerControls()
	Game.SetHudCartMode(false)
endFunction

int renn = 0

Int function GetVersion()
	return 402
endFunction

event OnVersionUpdate(int a_version)
	if (a_version >= 402 && CurrentVersion < 402)
		Spell Persistent = Game.GetFormFromFile(0x000693AB, "Thunderchild - Epic Shout Package.esp") as Spell
		if Game.GetPlayer().HasSpell(Persistent)
			Game.GetPlayer().DispelSpell(Persistent)
			Utility.Wait(0.5)			
			Game.GetPlayer().AddSpell(Persistent, false)
		endif
		Debug.Notification("Thunderchild: Fixed Persistent Spell.")
	endif
endEvent